
[Setup]
AppName=Win32Forth
AppVerName=Win32Forth 5.0.000
AppPublisher=Silicon Valley Chapter of the Forth Interest Group
AppPublisherURL=http://www.forth.org/sfig/index.htm
AppSupportURL=http://www.forth.org/sfig/index.htm
AppUpdatesURL=http://www.forth.org/sfig/index.htm
DefaultDirName={sd}\win32for
DefaultGroupName=Win32Forth 5.0
ChangesAssociations=yes
Compression=bzip/9
OutputBaseFilename=win32for5


[Tasks]
Name: "desktopicon1"; Description: "Create a &desktop icon to Win32for.exe"; GroupDescription: "Additional icons:"
Name: "desktopicon2"; Description: "Create a &desktop icon to Wined.exe"
Name: "desktopicon3"; Description: "Create a &desktop icon to Win32Forth directory "


[Files]
; these lines make a copy of  the existing files (if any) of the target dir to the backup dir
; giving a last chance to keeps somes files
;

Source: "{app}\486ASM.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\486ASM.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\486READ.ME"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0001.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0002.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0003.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0004.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0005.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0006.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\A0007.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ADJFORTH.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ANSFILE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ANSI.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\APP_ICON.ICO"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ARGS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ASMMAC.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ASMWIN32.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ASSERT.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\BANNER.BLK"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\BLOCK.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\BUILD.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\BUILTBY.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\BUTTON.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CALLBACK.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CHILDWND.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CLASDBG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CLASS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CLASSDBG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\COLORS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CONTROL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CONTROLS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\COPYASM.486"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\CTYPE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DBGSRC1.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DBGSRC2.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DC.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DEBUG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DIALOG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DIALOGRC.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DIALOGRC.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DIALOGS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DIS486.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DISCLAIM.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DLGTEST.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DLLTEST.C"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DLLTEST.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DLLTEST.MAK"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DLLTEST.RC"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS1.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS10.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS11.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS12.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS13.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS14.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS15.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS16.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS17.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS2.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS3.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS4.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS5.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS6.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS7.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS8.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANS9.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA1.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA10.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA11.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA12.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA13.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA14.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA15.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA16.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA17.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA2.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA3.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA4.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA5.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA6.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA7.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA8.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSA9.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSB.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSC.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSD.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSE.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DPANSF.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\DTHREAD.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ENVIRON.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\EXCEPTIO.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\EXTEND.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FCASES.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FILEDUMP.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FKERNEL.EXE"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FKERNEL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FKERNEL.IMG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FKERNEL.PRJ"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FLOAT.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FONTS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTH.C"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTH.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTH.RC"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLG.DLG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLG.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLG.RES"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.001"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.BAS"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.BIN"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.DEF"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.DSP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.DSW"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.FRM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.MAK"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.NCB"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.OPT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.RC"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\FORTHDLL.VBP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\GENERIC.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HAND.CUR"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HARROW.CUR"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HELLO.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HELP.CFG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HELP.NDX"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\HYPER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\IID.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\INTERPIF.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\KERNEL.BIN"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\KEYBOARD.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\KEYSAVE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\LAFIND.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\LATER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\LINEEDIT.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MAGNIFY.CUR"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MAPFILE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MARKUSED.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MENU.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MESSAGES.BAS"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MESSAGES.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MESSAGES.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\META.BAT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\META.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\MODULE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\NEWLAB.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\NFORGET.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\NOTES.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\OPTIMIZE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ORDER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\PIPES.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\POINTER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\PRIMES.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\PRIMHASH.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\PRIMUTIL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\PROFILE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\READ.ME"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\REGISTRY.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\RESDLL.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\RESFORTH.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\RESLOADT.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\RFILIST.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\ROMCALC.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\SCRNCTRL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\SEE.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\SPLITH.CUR"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\SPLITV.CUR"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\STARTUP.HTM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\STARTUP.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TASKER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TERM.C"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TERM.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TESTANSI.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TESTDLL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\TRANSIT.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\UNTITLED.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\UTILDOC.TXT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\UTILS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\VBTEST.FRM"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\VBTEST.MAK"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\VCALL.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\VERSION.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.001"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.BMP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.CFG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.DBG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.DSP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.DSW"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.EXE"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.FAQ"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.ICO"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.IMG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.MAK"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.NCB"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.NEW"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.OPT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.PLG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOR.PRV"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WIN32FOROLD.ICO"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINBROWS.BMP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINBROWS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINCLOCK.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINCON.DLL"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINDEMO.BMP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINDEMO.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINDILOG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINDOW.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.BMP"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.CFG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.COL"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.EXE"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.IMG"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.NDX"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINED.OPT"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINEDIT.H"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINEDIT.ICO"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINEDIT.RES"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINHELLO.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINLIB.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINMSG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINMULTI.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINPAR.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINSER.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WINSTACK.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\WORDS.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite
Source: "{app}\XDEBUG.F"; DestDir: "{app}\backup\"; Flags: external skipifsourcedoesntexist uninsneveruninstall; CopyMode: alwaysoverwrite

; must be as your source dir ( there this is :  c:\win32for)
Source: "C:\WIN32FOR\*"; DestDir: "{app}\"; CopyMode: alwaysoverwrite
Source: "C:\WIN32FOR\FKERNEL.EXE"; DestDir: "{app}"; DestName: "KERNEL.BIN"; CopyMode: alwaysoverwrite

[Icons]
Name: "{group}\Win32Forth "; Filename: "{app}\win32for.exe"; WorkingDir: "{app}"
Name: "{group}\WinView Editor"; Filename: "{app}\winview.exe"; WorkingDir: "{app}"
Name: "{group}\Win32Forth Release Notes"; Filename: "{app}\winview.exe"; Parameters: "/b win32for.new"; WorkingDir: "{app}"
Name: "{group}\Win32Forth Previous Notes"; Filename: "{app}\winview.exe"; Parameters: "/b win32for.prv"; WorkingDir: "{app}"
Name: "{group}\Make Winview"; Filename: "{app}\win32for.exe"; Parameters: "fload winview.f bye"; WorkingDir: "{app}"
Name: "{group}\Make Win32Forth"; Filename: "{app}\fkernel.exe"; Parameters: "fload extend.f bye"; WorkingDir: "{app}"
Name: "{group}\Meta Compile Kernel"; Filename: "{app}\win32for.exe"; Parameters: "fload meta.f setsize bye"; WorkingDir: "{app}"
Name: "{group}\Uninstall"; Filename:"{uninstallexe}"
Name: "{userdesktop}\Win32Forh"; Filename: "{app}\win32for.exe"; Tasks: desktopicon1
Name: "{userdesktop}\WinView"; Filename: "{app}\winview.exe"; Tasks: desktopicon2
Name: "{userdesktop}\Win32Forh Directory"; Filename: "{app}\"; Tasks: desktopicon3


[Registry]
Root: HKCR; Subkey: ".F"; ValueType: string; ValueName: ""; ValueData: "Win32Forth File"; Flags: uninsdeletevalue
Root: HKCR; Subkey: "Win32Forth File\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\WINVIEW.EXE"" ""%1"""
Root: HKCR; Subkey: "Win32Forth File\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\WIN32FOR.EXE,1"

[Run]
; This line builds win32for.exe and win32for.img during the setup process
Filename: "{app}\fkernel.exe"; Parameters: " s"" {app}\extend.f"" included bye"
; This line builds winview.exe and winview.img during the setup process
Filename: "{app}\win32for.exe"; Parameters: " s"" {app}\winview.f"" included bye"

Filename: "{app}\builtby.bat"
; This line launchs Win32for.exe if the user wants to
Filename: "{app}\win32for.exe"; Description: "Launch Win32Forth"; Flags: nowait postinstall skipifsilent unchecked
; This line launchs Winview.exe if the  user wants to
Filename: "{app}\wined.exe"; Parameters: "/b win32for.new"; Description: "Browse the Win32Forth.New File"; Flags: nowait postinstall skipifsilent unchecked

[UninstallDelete]
Type: files; Name: "{app}\WIN32FOR.EXE"
Type: files; Name: "{app}\WIN32FOR.IMG"

Type: files; Name: "{app}\WINED.EXE"
Type: files; Name: "{app}\WINED.IMG"




